// Copyright 2019-2020 UPF-N4 authors. All rights reserved.
// Use of this source code is governed by a MIT-style license that can be
// found in the LICENSE file.

package message_test

import (
	"n4/pkg/pfcp/ie"
	"n4/pkg/pfcp/internal/testutil"
	"n4/pkg/pfcp/message"
	"testing"
	"time"
)

func TestAssociationSetupRequest(t *testing.T) {

	//IE required for encapsulation
	nodeID := ie.NewNodeID("172.55.55.102", "", "")
	ts := ie.NewRecoveryTimeStamp(time.Date(2020, 3, 3, 12, 22, 22, 22, time.Local))
	//up := ie.NewUPFunctionFeatures(0x10, 0x00)
	cp := ie.NewCPFunctionFeatures(0x03)

	//ipv4 := net.ParseIP("192.168.2.146").To4()
	//ipv6 := net.ParseIP("2001:db8:130F:0000:0000:09C0:876A:130B").To16()
	//userPlaneIPResourceInformation1 := ie.NewUserPlaneIpResourceInformation(0, ipv4, ipv6, "111", 10)
	//userPlaneIPResourceInformation2 := ie.NewUserPlaneIpResourceInformation(0, ipv4, ipv6, "111", 10)
	//
	//alternativeSMFIPAddress1 := ie.NewAlternativeSMFIPAddress(ipv4, ipv6)
	//alternativeSMFIPAddress2 := ie.NewAlternativeSMFIPAddress(ipv4, ipv6)

	cases := []testutil.TestCase{
		{
			Description: "Normal",
			Structured: message.NewAssociationSetupRequest(
				nodeID, ts, cp),
			Serialized: []byte{
				0x20, 0x05, 0x00, 0x1a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x05, 0x00, 0xac, 0x37, 0x37, 0x66, 0x00, 0x60, 0x00, 0x04, 0xe2, 0x09, 0x3a, 0xfe, 0x00, 0x59, 0x00, 0x01, 0x03,
			},
		},
	}

	testutil.Run(t, cases, func(b []byte) (testutil.Serializable, error) {
		v, err := message.ParseAssociationSetupRequest(b)
		if err != nil {
			return nil, err
		}
		v.Payload = nil
		return v, nil
	})
}
